/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package servertest;

import java.io.*;
import java.net.*;
import java.util.ArrayList;
import javax.swing.JOptionPane;

/**
 *
 * @author Luca
 */
public class Server {
            private ServerSocket server;
            private Socket sock;
            
            public ArrayList connections;
            
            public Server(int Port)
            {   
                try
                {
                    server = new ServerSocket(Port);

                    while(true)
                    {
                        sock = server.accept();
                        
                        NewClient nc = new NewClient(sock);
                        nc.start();
                        
                        this.connections.add(nc); // qui fa errore
                        
                        System.out.println("Client connesso: "+String.valueOf(sock.getLocalSocketAddress()));                        
                    }
                }catch(IOException ex)
                {
                    JOptionPane.showMessageDialog(null,"Errore: "+ex);
                }
            }
            
        public class NewClient extends Thread {
            private Socket client;
            private BufferedReader br;
            private DataOutputStream dos;
            
            
            
            public NewClient(Socket sock)
            {
                this.client = sock;
                
                try
                {
                    this.br = new BufferedReader(new InputStreamReader(this.client.getInputStream()));
                    this.dos = new DataOutputStream(this.client.getOutputStream());
                }catch(IOException ex)
                {
                    JOptionPane.showMessageDialog(null,"Errore: "+ex);
                }
            }
            
            public String ReadLine()
            {
                String ts = null;
                
                try
                {
                    ts = this.br.readLine();
                }catch(IOException ex)
                {
                    JOptionPane.showMessageDialog(null,"Errore: "+ex);
                }
                
                return ts;
            }
            
            public void WriteLine(String text)
            {
                try
                {
                    this.dos.writeBytes(text);
                }catch(IOException ex)
                {
                    JOptionPane.showMessageDialog(null,"Errore: "+ex);
                }
            }
            
            public void run()
            {
                String ts = null;
                
                try {
                    while((ts = br.readLine()) != null)
                    {
                        System.out.println(ts);
                    }
                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(null,"Errore: "+ex);
                }
            }
            
        }
}
